<?php
/*
*-------------------------------phpMyBitTorrent--------------------------------*
*--- The Ultimate BitTorrent Tracker and BMS (Bittorrent Management System) ---*
*--------------   Created By Antonio Anzivino (aka DJ Echelon)   --------------*
*-------------               http://www.p2pmania.it               -------------*
*----------         Developed By Emad Hossam (aka emadness)          ----------*
*-------------               http://www.fulldls.com               -------------*
*------------ Based on the Bit Torrent Protocol made by Bram Cohen ------------*
*-------------              http://www.bittorrent.com             -------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*--   This program is free software; you can redistribute it and/or modify   --*
*--   it under the terms of the GNU General Public License as published by   --*
*--   the Free Software Foundation; either version 2 of the License, or      --*
*--   (at your option) any later version.                                    --*
*--                                                                          --*
*--   This program is distributed in the hope that it will be useful,        --*
*--   but WITHOUT ANY WARRANTY; without even the implied warranty of         --*
*--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          --*
*--   GNU General Public License for more details.                           --*
*--                                                                          --*
*--   You should have received a copy of the GNU General Public License      --*
*--   along with this program; if not, write to the Free Software            --*
*-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA --*
                                                                             --*
*------------------------------------------------------------------------------*
*------              2005 phpMyBitTorrent Development Team              ------*
*-----------               http://phpmybittorrent.com               -----------*
*------------------------------------------------------------------------------*
*/


require_once("include/config.php");

$phpver = phpversion();
if ($phpver < '4.1.0') {
    $_GET = $HTTP_GET_VARS;
    $_POST = $HTTP_POST_VARS;
    $_SERVER = $HTTP_SERVER_VARS;
}
ob_end_clean();
if (($phpver >= '4.0.4pl1' AND eregi("compatible",$_SERVER["HTTP_USER_AGENT"])) OR ($phpver > '4.0' AND eregi("gzip",$_SERVER["HTTP_ACCEPT_ENCODING"]))) {
        if (extension_loaded('zlib')) {
                ob_start("ob_gzhandler");
                header("Content-Encoding: gzip");

        }
} else {
        ob_start();
}
ob_implicit_flush(0);

function hash_where($name, $hash) {
    $shhash = preg_replace('/ *$/s', "", $hash);
    return "($name = '" . escape($hash) . "' OR $name = '" . escape($shhash) . "')";
}

function err($msg) {
        benc_resp(array("failure reason" => array(type => "string", value => $msg)));
        die();
}

function benc_resp($d) {
        benc_resp_raw(benc(array(type => "dictionary", value => $d)));
}
function hash_pad($hash) {
    return str_pad($hash, 20);
}
function benc_resp_raw($x) {
        header("Content-Type: text/plain");
        header("Pragma: no-cache");
        echo $x;
}


if (empty($info_hash)) $sql = "SELECT info_hash, seeders AS complete, completed AS downloaded, leechers AS incomplete FROM torrent_torrents ORDER BY info_hash;";
else $sql = "SELECT info_hash, seeders AS complete, completed AS downloaded, leechers AS incomplete FROM torrent_torrents WHERE ".hash_where("info_hash", urldecode($info_hash));

if (! $res = $db->sql_query($sql)) err("SQL ERROR: ".$sql);
if ($db->sql_numrows($res) < 1) err("Torrent not registered with this tracker.");

$r = "d" . benc_str("files") . "d";
while ($row = $db->sql_fetchrow($res)) {
        $r .= "20:" . hash_pad($row["info_hash"]) . "d" .
                benc_str("complete") . "i" . $row["complete"] . "e" .
                benc_str("downloaded") . "i" . $row["downloaded"] . "e" .
                benc_str("incomplete") . "i" . $row["incomplete"] . "e" .
                "e";
}
$r .= "ee";

benc_resp_raw($r);
ob_end_flush();
die();
?>
